#%RAML 1.0
version: v1
title: DB Function API
description: DynamoDB functions

types:
  dbGetResponseValid: !include Datatype/dbGetResponseValid.raml
  dbDeleteRequest: !include Datatype/dbDeleteRequest.raml
  dbDeleteResponseValid: !include Datatype/dbDeleteResponseValid.raml
  dbErrorResponse: !include exchange_modules/a9d53ff2-5476-4a1f-8d1a-b19eb82612cc/api-response-datatype-api/1.0.0/api-response-datatype-api.raml

traits:
  headerTrait: !include exchange_modules/a9d53ff2-5476-4a1f-8d1a-b19eb82612cc/header-securable/1.0.0/header-securable.raml   

/db/{msisdn}:
  uriParameters:
    msisdn:
        type: string
        description: Mobile Number of the Transaction
        example: "9718262123"
  get:
    is:
      - headerTrait
    description: Fetch the number of transactions with the mobile number used
    headers:
      correlationid:
        type: string
        description: Unique ID of the transaction
        example: "0-dbfedf90-284c-11e9-ac48-dca90494651"

    responses:
      200:
        body:
          application/json:
            type: dbGetResponseValid
            example: !include Examples/dbGet/dbGetResponseValidExample.json
      400:
        body:
          application/json:
            type: dbErrorResponse
            example: !include Examples/dbGet/dbGetResponseError400Example.json
      404:
        body:
          application/json:
            type: dbErrorResponse
            example: !include Examples/dbGet/dbGetResponseError404Example.json 
      405:
        body:
          application/json:
            type: dbErrorResponse
            example: !include Examples/dbGet/dbGetResponseError405Example.json
      406:
        body:
          application/json:
            type: dbErrorResponse
            example: !include Examples/dbGet/dbGetResponseError406Example.json
      415:
        body:
          application/json:
            type: dbErrorResponse
            example: !include Examples/dbGet/dbGetResponseError415Example.json
      501:
        body:
          application/json:
            type: dbErrorResponse
            example: !include Examples/dbGet/dbGetResponseError501Example.json
      500:
        body:
          application/json:
            type: dbErrorResponse
            example: !include Examples/dbGet/dbGetResponseError500Example.json
    
  delete:
    is:
      - headerTrait
    description: Delete the mobile number in the DB with the mobile number as URI parameter
    headers:
      correlationid:
        type: string
        description: Unique ID of the transaction
        example: "0-dbfedf90-284c-11e9-ac48-dca90494651"
    body:
      application/json:
        type: dbDeleteRequest
        example: !include Examples/dbDelete/dbDeleteRequestExample.json
    responses:
      200:
        body:
          application/json:
            type: dbDeleteResponseValid
            example: !include Examples/dbDelete/dbDeleteResponseValidExample.json
      400:
        body:
          application/json:
            type: dbErrorResponse
            example: !include Examples/dbDelete/dbDeleteResponseError400Example.json
      404:
        body:
          application/json:
            type: dbErrorResponse
            example: !include Examples/dbDelete/dbDeleteResponseError404Example.json 
      405:
        body:
          application/json:
            type: dbErrorResponse
            example: !include Examples/dbDelete/dbDeleteResponseError405Example.json
      406:
        body:
          application/json:
            type: dbErrorResponse
            example: !include Examples/dbDelete/dbDeleteResponseError406Example.json
      415:
        body:
          application/json:
            type: dbErrorResponse
            example: !include Examples/dbDelete/dbDeleteResponseError415Example.json
      501:
        body:
          application/json:
            type: dbErrorResponse
            example: !include Examples/dbDelete/dbDeleteResponseError501Example.json
      500:
        body:
          application/json:
            type: dbErrorResponse
            example: !include Examples/dbDelete/dbDeleteResponseError500Example.json